<?php

class CE_View_Helper_PriceAdaptiveSize extends Zend_View_Helper_Abstract {
  public function priceAdaptiveSize($currency, $priceInt, $priceDec, $term) {

      if (is_null($priceInt)) {
        $priceInt = "0";
      }

      $priceIntComparer = intval(preg_replace("/[^0-9]/", "", $priceInt));
      // need the &nbsp; below for layout purposes
      if (!$priceDec) {
        $priceDec = '&nbsp;';
      }
      if ($priceIntComparer < 1000) {
        $mainClass = 'pricesBig';
      } elseif ($priceIntComparer < 10000) {
        $mainClass = 'pricesMedium';
      } elseif ($priceIntComparer < 100000) {
        $mainClass = 'pricesSmall';
      } elseif ($priceIntComparer < 10000000) {
        $mainClass = 'pricesXSmall';
      } else {
        $mainClass = 'pricesXXSmall';
      }

      return <<<EOD
<div class="pricesWrapper $mainClass">
  <div class="price_large"><em>$currency</em><div class="price_large_num">$priceInt</div></div>
  <div class="price_small">$priceDec</div>
  <div class='head_pricing'>$term</div>
</div>
EOD;
  }
}
